package com.example.nto.service.impl;

import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.repository.CodeRepository;
import com.example.nto.repository.EmployeeRepository;
import com.example.nto.service.EmployeeService;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

import static org.springframework.util.Assert.hasText;

@Service
@RequiredArgsConstructor
public class EmployeeServiceImpl implements EmployeeService {

    private final EmployeeRepository employeeRepository;
    private final CodeRepository codeRepository;

    @Override
    public String getAuth(String login) {
        Employee employeeOptional = employeeRepository.findByLogin(login);
        if(employeeOptional==null){
            throw new ResponseStatusException(HttpStatus.UNAUTHORIZED);
        }
        return ("Данный логин существует - можно пользоваться приложением");
    }
    @Override
    public Employee getInfo(String login) {
        Employee employeeLogin=employeeRepository.findByLogin(login);
        if(employeeLogin==null) {
            throw new ResponseStatusException(HttpStatus.UNAUTHORIZED);
        }
        Optional<Employee> employeeOptional=employeeRepository.findById(employeeLogin.getId());

        return employeeOptional.get();
    }

    @Override
    public String patchOpen(String login, long value) {
        Employee employeeLogin=employeeRepository.findByLogin(login);
        Code codeValue=codeRepository.findByValue(value);
        if(employeeLogin==null) {
            throw new ResponseStatusException(HttpStatus.UNAUTHORIZED);
        }
        if(codeValue==null){
            throw new ResponseStatusException(HttpStatus.BAD_REQUEST);
        }

        return ("Дверь открыта");
    }
}
